#ifndef OVERLAND_HPP
#define OVERLAND_HPP

#include "geometry.hpp"

namespace Kernel{
  class Overland{
  private:
    const Geometry* geometry;
  public:
    //Input
    double* in_hov;
    double** previous_P;
    double* l;
    double* Pl;
    double* hydr;
    //Output
    double* Psoil; //Own by Overland object
    double* hov;
    double error;

    Overland();
    void init(const Geometry* geometry);
    void run();
  };

  inline
  Overland::Overland(){
  }

  inline void
  Overland::init(const Geometry* geometry_){
    geometry=geometry_;
    Psoil=new double[geometry->nX];
  }

}
#endif
